/*
 * Based on work from http://www.codeproject.com/KB/IP/IOlkAccountManager.aspx by Ashutosh Bhawasinka
 */

#pragma once

#include "OutlookAccountManagementAPI.h"

class CAccountHelper : public IOlkAccountHelper
{
public:
	CAccountHelper(LPCWSTR lpwszProfName, LPMAPISESSION lpSession);
	~CAccountHelper();

	// IUnknown
	STDMETHODIMP			QueryInterface(REFIID riid, LPVOID * ppvObj);
	STDMETHODIMP_(ULONG)	AddRef();
	STDMETHODIMP_(ULONG)	Release();

	// IOlkAccountHelper
	inline STDMETHODIMP PlaceHolder1(LPVOID)
	{
		return E_NOTIMPL;
	}

	STDMETHODIMP GetIdentity(LPWSTR pwszIdentity, DWORD * pcch);
	STDMETHODIMP GetMapiSession(LPUNKNOWN * ppmsess);
	STDMETHODIMP HandsOffSession();

private:
	LONG		m_cRef;
	LPUNKNOWN	m_lpUnkSession;
	LPWSTR		m_lpwszProfile;
	size_t		m_cchProfile;
};